package cn.palmte.work.service;


import cn.palmte.work.config.activiti.ActConstant;
import com.alibaba.fastjson.JSONObject;
import org.activiti.engine.delegate.DelegateExecution;
import org.activiti.engine.delegate.DelegateTask;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.util.Iterator;
import java.util.List;
import java.util.Set;


/**
 * 流程节点监听
 */
@Service
public class ActListenerService {
    private static final Logger logger = LoggerFactory.getLogger(ActListenerService.class);


    @Autowired
    private ActTaskDefService actTaskDefService;

    @Autowired
    private ProjectInstanceService projectInstanceService;

    /**
     * 节点创建监听 动态设置审批人
     *
     * @param delegateTask
     * @throws Exception
     */
    public void create(DelegateTask delegateTask) throws Exception {
        logger.info("--- {}", JSONObject.toJSONString(delegateTask));

        String procDefId = delegateTask.getProcessDefinitionId();
        String procInsId = delegateTask.getProcessInstanceId();
        String taskDefKey = delegateTask.getTaskDefinitionKey();
        List<String> candidateUsers = actTaskDefService.findCandidateUsers(procDefId, procInsId, taskDefKey);
        logger.info("addCandidateUsers : {}", candidateUsers);


        Object projectIdObj = delegateTask.getVariable(ActConstant.KEY_PROJECT_ID);
        logger.info("projectIdObj : {}", projectIdObj);

        if (candidateUsers != null && !candidateUsers.isEmpty() && projectIdObj != null) {
            try {
                int adminId = Integer.parseInt(candidateUsers.get(0));
                projectInstanceService.updateApprover((Integer) projectIdObj, adminId);
            } catch (Exception e) {
                logger.error("", e);
            }
        }

        delegateTask.addCandidateUsers(candidateUsers);
    }


    /*public void multiTaskcreate(DelegateTask delegateTask) throws Exception {
        logger.info("--- {}", JSONObject.toJSONString(delegateTask));

        String procDefId = delegateTask.getProcessDefinitionId();
        String procInsId = delegateTask.getProcessInstanceId();
        String taskDefKey = delegateTask.getTaskDefinitionKey();
        Set<String> candidateUsers = actTaskDefService.findCandidateUsers(procDefId, procInsId, taskDefKey);
        logger.info("addCandidateUsers : {}", candidateUsers);
        delegateTask.addCandidateUsers(candidateUsers);
    }*/


    public List<String> multipleInstanceTask(DelegateExecution delegateExecution) throws Exception {
        String procInsId = delegateExecution.getProcessInstanceId();
        String procDefId = delegateExecution.getProcessDefinitionId();
        String taskDefKey = delegateExecution.getCurrentActivityId();

        return actTaskDefService.findCandidateUsers(procDefId, procInsId, taskDefKey);
    }

}
